<template>
  <div id="wrapper">
    <!-- <img id="logo" src="~@/assets/logo.png" alt="electron-vue"> -->
    <main>
    </main>
  </div>
</template>

<script>
  import Warn from './warnDev' // "Pseudo anti asserts" for quicker error detection during development
  import XRegExp from 'xregexp'

  const { ipcRenderer } = require('electron')

  export default {
    name:       'editor-page',
    components: { Warn },
    data () {
      return {
        composition: [

        ],
        focus,
      }
    },
    computed: {},

    created () {
      ipcRenderer.on('request', this.onRequest)
      window.addEventListener('keydown', this.onKey)
      window.addEventListener('focusin', this.onFocus)
      window.addEventListener('focusout', this.offFocus)
      // window.addEventListener('resize', this.onResize)
    },
    beforeDestroy () {
      // window.removeEventListener('resize', this.onResize)
      window.removeEventListener('focusout', this.offFocus)
      window.removeEventListener('focusin', this.onFocus)
      window.removeEventListener('keydown', this.onKey)
      ipcRenderer.removeAllListeners()
    },

    methods: {
      // open (link) { this.$electron.shell.openExternal(link) },
      offFocus () { this.focus = null },
      onFocus (e) { this.focus = e.target },
      onRequest (event, data) {
      },
      onKey (e) {
        // e.preventDefault()
        // console.log(this.focus)

        // Cancel if any text-field focused, other than the main one
        // if (this.focus !== this.$refs.qc && this.focus && this.focus.nodeName==='INPUT' && this.focus.type==='text')
        //   return

        // Don't perform side-effects on (only) Shift, Alt, etc.
        if (e.key === 'Shift' || e.key === 'Control' || e.key === 'Alt') return
        if (e.key === 'Tab') return

        // If no other "textbox"´is focussed -> focus
        if (!this.focus || (this.focus.type!=='text' && this.focus.type!=='textarea'))
          this.$refs.qc.focus()

        // Process only if focussed
        if (this.focus === this.$refs.qc && e.key === 'Enter') {
          // this.history.push(this.$refs.qc.value)
          // this.historyOffset = this.history.length - 1
          this.$refs.qc.value = this.evaluateQuickcode(this.$refs.qc.value /* this.selected */)
        }

        // Key combinations / shortcuts
        this.evaluateShortcuts(e) // e.g. "Alt + Enter"
      },
      evaluateShortcuts (e) {
        var alt = e.altKey // <- OSX, etc.
        // var selectIndex = this.openedComp.c.indexOf(this.selected)
        // var sheikhFactor = this.openedComp.c.length // amount of children

        console.log('Keyevent:', e)

        if (alt)
          switch (e.key) {
            // Alt + Delete
            case 'Delete': this.deleteComponent(); break

            // Alt + Up / Down
            case 'ArrowUp':
              if (this.openedComp.c.length > 0)
                this.selectIndex = (this.selectIndex <= -1) ?this.openedComp.c.length-1 :this.selectIndex-1
              console.log('SEL COMP:', this.selectComp)
              break

            case 'ArrowDown':
              if (this.openedComp.c.length > 0)
                this.selectIndex = (this.selectIndex >= this.openedComp.c.length-1) ?-1 :this.selectIndex+1 // this.selected = (selectIndex === sheikhFactor-1) ?this.openedComp.c[0] :this.openedComp.c[selectIndex-1]
              break

            // Alt + Right [or]
            // Alt + Enter
            case 'Enter': // <== also the quickcode statement is evaluated beforehand
            case 'ArrowRight':
              this.$electron.ipcRenderer.send('ping')
              console.log('selIndex', this.selectIndex)
              // console.log('toopen:', (this.selectIndex === -1)) // openedComp === this.selected.z))
              // // ? (this.openedComp.c[this.openedComp.c.length-1].comp)
              // // : (this.selected.comp))
              // console.log('letztes el:', this.openedComp.c[this.openedComp.c.length-1].z)
              // console.log('selectedel:', this.selected.z)
              // console.log('openedComp:', this.openedComp)
              if (this.openedComp.c.length === 0) break
              if (this.selectIndex === -1) break
              this.ancestors.push(this.openedComp)
              this.openedComp = this.selectComp
              this.selectIndex = -1
              // console.log('selected.comp', this.selected.comp)
              // this.openComponent(this.selectIndex === -1
              //   ? this.openedComp.c[this.openedComp.c.length-1].z
              //   : this.selected.z)
              break

            // Alt + Left [or]
            // Alt + Escape (possibly reconsider?)
            case 'Escape':
            case 'ArrowLeft':
              let newTarget = this.ancestors.length
                ? this.ancestors.pop()
                : this.composition[0]
              // set previous child component as selected
              this.selectIndex = newTarget.c.findIndex(inst => inst.z===this.openedComp)
              // (newTarget.c.indexOf(this.openedComp)!==-1)
              //   ? newTarget.c.indexOf(this.openedComp)
              //   : -1
              this.openedComp = newTarget
              break
          }
        // if (e.key === 'ArrowUp') {
        //   if (this.historyOffset <= 0) return
        //   if (this.historyOffset === this.history.length - 1) this.history.push(this.$refs.qc.value)
        //   this.$refs.qc.value = this.history[--this.historyOffset]
        //   e.preventDefault()
        // }
        // if (e.key === 'ArrowDown') {
        //   if (this.historyOffset === this.history.length - 1 && this.$refs.qc.value.trim() === '') return
        //   if (this.historyOffset === this.history.length - 1) this.history.push('')
        //   this.$refs.qc.value = this.history[this.historyOffset++]
        //   e.preventDefault()
        // }
      },
      // TODO: E.g. cick-handlers should also call 'evaluateQuickcode' with code which is evaluated here
      evaluateQuickcode (code /* selected */) {
        // var assert = require('assert')
        // assert(selected !== null)
        // alert('evaluate: ' + code + ', for: ' + selected)

        // -------------------------------------------------------------------------------------- //

        // Execute multiple commands (recursively)
        if (code.indexOf(';') !== -1) {
          // console.log('Multiple commands:', code)
          code.split(';').forEach(val => { if (this.evaluateQuickcode(val) !== '') return code })
          return ''
        }

        // Basic command evaluation (via regex)
        // const regex = /^(\?[^:]*)?: *([\w \u00C0-\u02AF]*):?([\w \u00C0-\u02AF]*)(?:\*([1-9][0-9]?|100))? *$/g
        // const regex = XRegExp(`^ *(\\? *\\pL(?:\\pL|[ ])*): *(\\pL(?:\\pL| )*):?(\\pL(?:(\\pL| )*)(?:\\*([1-9][0-9]?|100))? *$`, 'gA') // partial tests ([\w \u00C0-\u02AF]*):?([\w \u00C0-\u02AF]*)(?:\*([1-9][0-9]?|100))? *$`, 'gA') // (A)Astral, (x)free spacing (nu), (s)dot match all (not yet used)
        // const regex = XRegExp(`^(?: *(?:\\?(\\p{L}| )*)? *\\:)?((?:\\p{L}| )*)?(?:\\: *(\\p{^C}*))?(?:\\*([1-9][0-9]?|100))? *$`, 'A') // complete but simplified (e.g. trimming necessary), allows for either multiples [e.g. comp*4] OR description [e.g. comp:This is a desc with: colon]

        // Structuring ideas (grouping?)
        // const basic = {
        //   cond: '^\\?$',
        //   comp: '^ *$',
        //   desc: XRegExp('^\\p{^C}*$'),
        // }
        // const regex = XRegExp.build('^{{add}}|{{rename}}$', {
        //   add:    XRegExp.build('^ *{{cond}}\\: *{{comp}} *(\\:{{desc}})?$', basic),
        //   rename: XRegExp.build('^\\: *{{comp}}$', basic),
        // }, 'A')

        // TODO: Possibly, rework if multiline entries are allowed
        const regex = XRegExp.build(/^(?:{{cond}}|{{list}})?{{name}}{{mult}}?{{desc}}?$|^{{desc}}$|^{{cond}}$/, { // (?:{{desc}}|{{mult}})?$/, { // *(\\:{{desc}})?$', {
        // const regex = XRegExp.build(/^{{cond}}?{{name}}{{mult}}?{{desc}}?$|^{{desc}}$/, { // working well
          cond: /^\? *((?:\pL| )*?) *\: *$/, // Only letters and spaces ("trimmed"), also empty ("?:") allowed!
          list: /^\* *((?:\pL| )*?) *\: *$/,
          // loop: /^\*$/,
          // comp: /^ *(\pL(?:\pL| )*?) *$/, // /^ *(\p{L}*)$/,
          name: /^ *(\pL(?:\pL| )*?) *$/,
          desc: /^\: *([^\x00-\x1A]*?) *$/, // everything except control chars (be careful, still very greedy!)
          mult: /^\* *([1-9][0-9]?|100) *$/,
        }, 'A')

        // console.log(regex.test(code))
        // const match = code.trim().match(regex)
        const match = regex.exec(code)
        // const match = XRegExp.exec(code, regex) // also adds named attributes (e.g. match.cond (when directly surrounded by extra brackets e.g. ({{cond}}) )), but would require lookarounds to get rid of spaces etc.
        console.table(match)
        if (!match)
          return code

        const cond = match[1]
        const list = match[2]
        const name = match[3]
        const desc = match[5]
        const mult = match[4]
        const existing = this.composition.find(e => e.a === name) // find vs some => boolean result
        // console.log('ex', existing)
        const onlyDesc = match[6] // e.g. ":new description"
        const onlyCond = match[7] // e.g. "?new condition:" (works only with/for a selected component instance)

        // if (cond) {
        //   console.log('TODO: implement condition,', cond)
        //   // const condition_regex = /^[\w \u00C0-\u02AF]*==$/g

        //   // XRegExp instead of regex (missing recursive matching, unicode support, and)
        //   const condRegex = XRegExp(``)
        //   console.log(condRegex)
        // }

        // -------------------------------------------------------------------------------------- //

        // asdfvar colon = code.indexOf(':')
        // var quest = code.indexOf('?')

        // switch (code[0]) {
        //   case '<': if (colon!==-1) return code; this.setA(code.substring(1)); return ''
        // }

        // Only change the currently selected description
        if (onlyDesc) {
          this.selectComp.b = onlyDesc
          return ''
        }

        if (onlyCond !== undefined) {
          if (!this.selectInst)
            return code
          this.selectInst.x = onlyCond
          return ''
        }

        // Component name specified
        if (name) {
          // Find existing component, or create new one
          const component = existing || {a:name, b:desc||'', c:[], p:[]}
          if (!existing) this.composition.push(component)

          // Add component to opened component
          for (var i=mult||1; i>0; i--) {
            var inst = {z:component}

            // Add condition, if it was supplied
            if (cond)
              inst.x = cond // simple string, therefore not same instance
            if (list)
              inst.l = list

            // Push separate changeable insts
            this.openedComp.c.push(inst) // this.addComponent(component)
          }

          console.log(this.openedComp.c.length)
          console.log(this.selectIndex)
          if (this.setting.autoselect_new_comp && (this.selectIndex === -1 || this.selectIndex === (this.openedComp.c.length-2))) {
            this.selectIndex = this.openedComp.c.length-1 // select last component
          }
        } else if (desc && mult)
          return code

        // // No colon
        // if (colon === -1)
        //   this.selected.c.push({a:code.trim(), c:[]})
        // // Starting colon
        // else if (colon === 0)
        //   this.setB(code.substring(1)) // assignment without curlies, not that beautiful (change linting?)
        // else {
        //   // s = code.split(':')
        //   // this.selected.c.push({a:code.substring(0, colon).trim(), b:code.substring(colon+1).trim(), c:[]})
        //   this.addC(code.substring(0, colon), code.substring(colon+1)) // , c:[]})
        // }

        return ''
      },
      // setA (a) { this.selected.a = a },
      // setB (b) { this.selected.b = b },
      // addC (a, b) { this.selected.c.push({a:a.trim(), b:b.trim(), c:[]}) },
      // addComponent (comp) {
      //   this.composition.push(comp)
      //   this.selected.c.push({z:comp})
      // },
      // TODO: (Bug) Problems with deleting correct index ...
      deleteComponent () {
        if (!this.openedComp.c[this.selectIndex])
          return
        // Remove the selected component instance and select the one above
        this.openedComp.c.splice(this.selectIndex, 1)
        if (this.selectIndex >= (this.openedComp.c.length)) this.selectIndex--
      },
      // openComponent (comp) {
      //   // if (this.selectIndex === -1 && this.selected.c.length === 0)
      //   //   return

      //   if (!comp)
      //     return

      //   // Store openedComp parent component
      //   this.ancestors.push(this.openedComp)
      //   this.openedComp = comp
      //   this.selectIndex = -1
      // },
    },
  }
</script>

<style src="primevue/resources/themes/saga-blue/theme.css" scoped />
<style src="primevue/resources/primevue.min.css" scoped />
<style src="primeicons/primeicons.css" scoped />
<style scoped>

  /* 
  @import url('https://fonts.googleapis.com/css?family=Source+Sans+Pro');

  * {
    box-sizing: border-box;
    margin: 0;
    padding: 0;
  }
  body { font-family: 'Source Sans Pro', sans-serif; }
  .pad { padding:2.5rem; } 
  */

  .quickcode { margin:10px 0; padding:2px; }

  #wrapper {
    
    background:
      radial-gradient(
        ellipse at top left,
        rgba(255, 255, 255, 1) 40%,
        rgba(229, 229, 229, .9) 100%
      );
    min-height: 100vh; /* min-height because of possible overflow */
    padding: 40px 40px;
    width: 100vw;
  }

  #logo {
    height: auto;
    margin-bottom: 20px;
    width: 420px;
    /* display: none; */
    display: none;
  }

  .title {
    color: #2c3e50;
    font-size: 20px;
    font-weight: bold;
    margin-bottom: 6px;
    opacity:0.5;
  }

  .subtitle {
    opacity:0.7;
  }

  .intro { margin-top:2rem; }
  .intro p, .intro li{
    font-family: 'Courier New', Courier, monospace;
  }
  .intro h2 {
    color:gray;
    font-family:inherit;
    margin-bottom:1rem;
  }
  .intro>ul {
    margin:0.5rem 2px;
  }

  main {
    display: flex;
    justify-content: space-between;
  }
  main > div { flex-basis: 33%; }

  .left-side {
    /* padding:5rem 5rem 0 0; */
    margin:5.5rem 0;
    flex-basis: 20%;
  }
    /* .p-listbox { } */
    /* .p-listbox-item { } */
    .p-component {
      font-size:1.5rem;
    }

  .center {
    flex-basis:50%;
    display: flex;
    flex-direction: column;
    margin:0 4rem;
    /* background:gray; */
  }

  .right-side {
    flex-basis:30%;
    margin:5.5rem 0rem;
    /* background:blue; */
  }

</style>
